# -*- coding: utf-8 -*-
# Generated by Django 1.11 on 2017-12-12 05:46
from __future__ import unicode_literals

from django.db import migrations
from django.db.migrations import RunPython


def create_builtin_templates_variables(apps, schema_editor):
    template_model = apps.get_model('customer', 'CommunicationEventType')
    variable_model = apps.get_model('customer', 'CommunicationEventTypeTestVariable')

    comm_event_types = [
        {
            'code': 'CLIENT_ORDER_RECEIPT',
            'name': 'Уведомление клиента о заказе',
            'variables': [
                {
                    'code': 'total',
                    'description': 'стоимость заказа (включая доставку)'
                },
                {
                    'code': 'date_placed',
                    'description': 'дата создания заявки'
                },
                {
                    'code': 'payment_method',
                    'description': 'способ оплаты'
                },

                {
                    'code': 'shipping',
                    'description': 'стоимость доставки'
                },
                {
                    'code': 'shipping_charge_resolved',
                    'description': 'стоимость доставки определена'
                },
                {
                    'code': 'shipping_date',
                    'description': 'дата доставки'
                },
                {
                    'code': 'shipping_method.name',
                    'description': 'способ доставки: название'
                },
                {
                    'code': 'shipping_method.description',
                    'description': 'способ доставки: описание'
                },


                {
                    'code': 'shipping_address.onestring',
                    'description': 'исходная строка с адресом'
                },
                {
                    'code': 'shipping_address.region',
                    'description': 'регион'
                },
                {
                    'code': 'shipping_address.city',
                    'description': 'город'
                },
                {
                    'code': 'shipping_address.street',
                    'description': 'улица'
                },
                {
                    'code': 'shipping_address.house',
                    'description': 'дом'
                },
                {
                    'code': 'shipping_address.flat',
                    'description': 'квартира'
                },

                {
                    'code': 'shipping_contacts.name',
                    'description': 'имя'
                },
                {
                    'code': 'shipping_contacts.phone_number',
                    'description': 'номер телефона'
                },
                {
                    'code': 'shipping_contacts.email',
                    'description': 'email'
                },
                {
                    'code': 'shipping_contacts.notes',
                    'description': 'заметки от клиента'
                },
            ]
        },
    ]

    for comm_event_type in comm_event_types:
        template, created = template_model.objects.get_or_create(code=comm_event_type['code'], defaults={
            'name': comm_event_type['name']
        })
        for variable in comm_event_type['variables']:
            variable_model.objects.create(
                template=template,
                code=variable['code'],
                description=variable['description'],
            )

class Migration(migrations.Migration):

    dependencies = [
    ]

    operations = [
        RunPython(create_builtin_templates_variables)
    ]

